package Mammoth.AI.NPC.SCXML;

import java.util.HashMap;

import Mammoth.AI.NPC.NPCEvent;
import Mammoth.AI.NPC.Role;
import Mammoth.AI.PathFinding.PathFindingManager.PathType;
import Mammoth.PhysicsEngine.PhysicsEngine;
import Mammoth.WorldManager.Position;
import Mammoth.WorldManager.WorldManager;
import Mammoth.WorldManager.Actions.ActionException;
import Mammoth.WorldManager.Actions.ActionExecutor;
import Mammoth.WorldManager.Actions.DespawnAction;
import Mammoth.WorldManager.Actions.MoveAction;
import Mammoth.WorldManager.Actions.SpawnAction;

import com.jme3.animation.LoopMode;

public class SCXMLClimbTreeActuator extends SCXMLTask {

	private static final String DEFAULT_SCXML = "SCXMLClimbActuator.scxml";
	private boolean upTree;
	private long timer;
	private final int HIDE_TIME = 13000;

	public SCXMLClimbTreeActuator(Role npc) {
		super(npc, DEFAULT_SCXML);
		upTree = false;
	}

	// create a new WanderTask with external parameters
	public SCXMLClimbTreeActuator(Role npc, String scxmlFile,
			HashMap<String, Object> params) {
		super(npc, scxmlFile, params);
	}

	public void init() {

		HashMap<String, Object> context = new HashMap<String, Object>();
		context.put("this", this);

		this.setContext(context);
		this.startExecution();
	}

	public void climbTree() {
		upTree=true;
		timer=0;
		try {
			this.createAIEvent("stop_move", null);
			//System.out.println(npc.getPlayer().getName() + "climbed a tree");
			ActionExecutor.executeSingleAction(new DespawnAction(npc.getWorldManager(), npc.getPlayer()));
		} catch (ActionException e) {		
			this.createGameEvent("climb_failed", null);
		}
	}

	public void update(long timestep, WorldManager world, PhysicsEngine physics) {
		if (upTree) {
			timer+=timestep;
			if (timer > HIDE_TIME) {
				upTree = false;
				try {
					//System.out.println(npc.getPlayer().getName() + "came back down.");
					ActionExecutor.executeSingleAction(new SpawnAction(world, npc.getPlayer()));
				} catch (ActionException e) {
					this.createGameEvent("climb_failed", null);
				}
				this.fireEvent(new NPCEvent("timer_up"));
			}
		}
	}

}
