package Mammoth.AI.NPC.SCXML;

import java.util.HashMap;
import java.util.LinkedList;

import Mammoth.AI.NPC.Role;
import Mammoth.PhysicsEngine.PhysicsEngine;
import Mammoth.WorldManager.WorldManager;
import Mammoth.WorldManager.WorldObject;
import Mammoth.WorldManager.Actions.ActionException;
import Mammoth.WorldManager.Actions.ActionExecutor;
import Mammoth.WorldManager.Actions.GameAction;
import Mammoth.WorldManager.Actions.IncrementEnergyAction;
import Mammoth.WorldManager.Actions.DespawnAction;

public class SCXMLEatActuator extends SCXMLTask {

	private static final String DEFAULT_SCXML = "SCXMLEatActuator.scxml";
	
	public SCXMLEatActuator(Role npc) {
		super(npc, DEFAULT_SCXML);		
		//threats = new Vector<Player>();
	}
	
	//create a new SCXMLPickUpTask with external parameters
	public SCXMLEatActuator(Role npc, String scxmlFile, HashMap<String, Object> params) {		
		super(npc, scxmlFile, params);
	}
	
	public void init() {
		HashMap<String,Object> context = new HashMap<String,Object>();
		
		context = new HashMap<String, Object>();
		context.put("this", this);
		
		this.setContext(context);
		this.startExecution();
	}
	
	public void eatAcorn() {
		try {
			//composite action
			LinkedList<GameAction> compAct = new LinkedList<GameAction>();
			compAct.add(new IncrementEnergyAction(npc.getPlayer(), 20000));
			compAct.add(new DespawnAction(npc.getWorldManager(), (WorldObject)(npc.getPlayer().getItemsInInventory().toArray()[0])));
			ActionExecutor.executeCompositeAction(compAct);
		} catch (ActionException e) {
			
			//FEEDBACK GOES HERE
			e.printStackTrace();
		}
	}

	public void update(long timestep, WorldManager world, PhysicsEngine physics) {
		
	}

}
