package Mammoth.AI.NPC.SCXML;

import java.util.HashMap;
import java.util.Vector;

import Mammoth.AI.NPC.Role;
import Mammoth.PhysicsEngine.PhysicsEngine;
import Mammoth.WorldManager.ItemObject;
import Mammoth.WorldManager.WorldManager;

public class SCXMLEatDecider extends SCXMLTask {

	private HashMap<String, Object> context;
	private ItemObject target;
	private SCXMLItemMemorizer itemMemorizer;
	
	private Class reference;
	
	public SCXMLEatDecider(Role npc, String scxmlFile,
			HashMap<String, Object> params) {
		super(npc, scxmlFile, params);
	}

	@Override
	public void update(long timestep, WorldManager world, PhysicsEngine physics) {
	}

	@Override
	public void init() {
		ItemObject target = null;
		
		context = new HashMap<String, Object>();
		context.put("this", this);
		context.put("target", target);

		this.setContext(context);
		this.startExecution();
	}
		
	public void pickTarget() {
		Vector<ItemObject> targets = itemMemorizer.getKeyItemList();

//		//get closest
//		ItemObject closest = null;
//		double closestDist = 999999999;
//		for (ItemObject acorn: targets) {
//			double dist = npc.getPlayer().getPosition().getPoint().distance(acorn.getPosition().getPoint()); 
//			if (dist < closestDist) {
//				closest = acorn;
//				closestDist = dist;
//			}
//		}
//		target = closest;
		
		//nothing fancy, just get a random one
		int choice = (int)Math.floor(Math.random() * targets.size());
		target = targets.get(choice);
		context.put("target", target);
	}
	
	public boolean foodVisible() {
		Vector<ItemObject> targets = itemMemorizer.getKeyItemList();
		if (targets.isEmpty()) {
			return false;
		}
		return true;
	}

}
