package Mammoth.AI.NPC.SCXML;

import java.util.HashMap;

import Mammoth.AI.NPC.Role;
import Mammoth.PhysicsEngine.PhysicsEngine;
import Mammoth.WorldManager.ItemObject;
import Mammoth.WorldManager.WorldManager;
import Mammoth.WorldManager.Actions.ActionExecutor;
import Mammoth.WorldManager.Actions.PickupAction;

public class SCXMLPickUpActuator extends SCXMLTask {

	private static final String DEFAULT_SCXML = "SCXMLPickUpActuator.scxml";
	
	private HashMap<String, Object> context;
	private ItemObject target;
	
	public SCXMLPickUpActuator(Role npc) {
		
		super(npc, DEFAULT_SCXML);

	}
	
	//create a new SCXMLPickUpTask with external parameters
	public SCXMLPickUpActuator(Role npc, String scxmlFile, HashMap<String, Object> params) {		
		super(npc, scxmlFile, params);
	}
	
	public void init() {
		context = new HashMap<String, Object>();
		context.put("this", this);

		target=null;
		
		this.setContext(context);
		this.startExecution();
	}
	
	public void setTarget(ItemObject target) {
		if (target == null) {
			System.out.println("NULL PICKUP1");
		}
		this.target = target;
	}
	
	public void pickupItem() {
		try {
			ActionExecutor.executeSingleAction(new PickupAction(npc.getPlayer(), target));
			
			if (npc.getPlayer().containsItem(target)) {
				createGameEvent("pick_up_successful", null);
			}
			else {
				createGameEvent("pick_up_failed", null);
			}
		}
		catch (Exception e) {
			createGameEvent("pick_up_failed", null);
		}
	}
	
	public void update(long timestep, WorldManager world, PhysicsEngine physics) {
		
	}
	
}
