package Mammoth.AI.NPC.SCXML;

import java.util.HashMap;

import Mammoth.AI.NPC.NPCEvent;
import Mammoth.AI.NPC.Role;
import Mammoth.AI.NPC.RoleImpl;
import Mammoth.PhysicsEngine.PhysicsEngine;
import Mammoth.WorldManager.ItemObject;
import Mammoth.WorldManager.Player;
import Mammoth.WorldManager.WorldManager;

public class SCXMLPickUpExecutor extends SCXMLTask {
	
	private HashMap<String, Object> context;
	private ItemObject target;
	
	private static final String DEFAULT_SCXML = "SCXMLPickupExecutor.scxml";

	public SCXMLPickUpExecutor(Role npc) {
		super(npc, DEFAULT_SCXML);
	}
	
	//create a new WanderTask with external parameters
	public SCXMLPickUpExecutor(Role npc, String scxmlFile, HashMap<String, Object> params) {		
		super(npc, scxmlFile, params);
	}

	public void init() {
		
		target = null;
		
		context = new HashMap<String, Object>();
		context.put("this", this);
		context.put("target", target);
		
		this.setContext(context);
		this.startExecution();
	}
	
	public void setTarget(ItemObject target) {
		this.target = target;
		this.getEngine().getRootContext().set("target", target);
	}
	
	public boolean isTargetReachable() {
		if (target.getPosition().getPoint().distance(((RoleImpl)npc).getPosition().getPoint()) < Player.REACHABILITY_RADIUS){
			return true;
		}
		return false;
	}
	
	public void prepareDestination() {
		this.getEngine().getRootContext().set("destination", target.getPosition().clone());
	}

	public void update(long timestep, WorldManager world, PhysicsEngine physics) {
		//fire null event to ensure conditions are checked.
		this.fireEvent(new NPCEvent("null"));		
	}
}
